/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20101209-64 [Dec 25 2010]
 * Copyright (c) 2000 - 2010 Intel Corporation
 * 
 * Disassembly of SSDT2.dat, Thu Jul 14 12:15:14 2011
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000D7A (3450)
 *     Revision         0x01
 *     Checksum         0x7E
 *     OEM ID           "AmdRef"
 *     OEM Table ID     "AmdTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */

DefinitionBlock ("SSDT2.aml", "SSDT", 1, "AmdRef", "AmdTabl", 0x00001000)
{
    External (P8XH, MethodObj)    // 2 Arguments
    External (AMDA, MethodObj)    // 1 Arguments
    External (\SGAK, MethodObj)    // 1 Arguments
    External (\SGNX, MethodObj)    // 6 Arguments
    External (\SVSA, MethodObj)    // 1 Arguments
    External (\SGED, MethodObj)    // 1 Arguments
    External (\SGPU, MethodObj)    // 1 Arguments
    External (\VFAN, MethodObj)    // 1 Arguments
    External (\GPOW, IntObj)
    External (\PGPU, MethodObj)    // 4 Arguments
    External (\RGPU, MethodObj)    // 6 Arguments
    External (\_SB_.SGFN)
    External (\_SB_.SGRQ, IntObj)
    External (\_SB_.PCI0.VGA_, DeviceObj)
    External (\_SB_.PCI0.RP00.VGA_, DeviceObj)
    External (\_SB_.PCI0.RP00.EHDA, DeviceObj)

    Scope (\_SB.PCI0.RP00.EHDA)
    {
        OperationRegion (PEGR, PCI_Config, Zero, 0x0100)
        Field (PEGR, DWordAcc, Lock, Preserve)
        {
                    Offset (0x4C), 
            SSID,   32
        }
    }

    Scope (\_SB.PCI0.RP00.VGA)
    {
        OperationRegion (RPCI, SystemMemory, 0xF8008000, 0x1000)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
                    Offset (0x1FC), 
                    Offset (0x1FD), 
            RFC9,   1, 
                    Offset (0x214), 
                    Offset (0x216), 
            LNKS,   4, 
                    Offset (0x224), 
                    Offset (0x225), 
            DQDA,   1, 
                    Offset (0xC28), 
            HCLQ,   1, 
                    Offset (0xC34), 
                ,   30, 
            PEDQ,   1, 
            PIDQ,   1, 
                    Offset (0xDFC), 
                ,   1, 
            PEPO,   3, 
                    Offset (0xE08), 
                ,   31, 
            ROE0,   1, 
                    Offset (0xE28), 
                ,   31, 
            ROE1,   1, 
                    Offset (0xE48), 
                ,   31, 
            ROE2,   1, 
                    Offset (0xE68), 
                ,   31, 
            ROE3,   1, 
                    Offset (0xE88), 
                ,   31, 
            ROE4,   1, 
                    Offset (0xEA8), 
                ,   31, 
            ROE5,   1, 
                    Offset (0xEC8), 
                ,   31, 
            ROE6,   1, 
                    Offset (0xEE8), 
                ,   31, 
            ROE7,   1, 
                    Offset (0xF08), 
                ,   31, 
            ROE8,   1, 
                    Offset (0xF28), 
                ,   31, 
            ROE9,   1, 
                    Offset (0xF48), 
                ,   31, 
            ROEA,   1, 
                    Offset (0xF68), 
                ,   31, 
            ROEB,   1, 
                    Offset (0xF88), 
                ,   31, 
            ROEC,   1, 
                    Offset (0xFA8), 
                ,   31, 
            ROED,   1, 
                    Offset (0xFC8), 
                ,   31, 
            ROEE,   1, 
                    Offset (0xFE8), 
                ,   31, 
            ROEF,   1
        }

        OperationRegion (DMIB, SystemMemory, 0xFED18000, 0x1000)
        Field (DMIB, DWordAcc, Lock, Preserve)
        {
                    Offset (0xC34), 
            LLGE,   1, 
                ,   28, 
            PCGE,   1, 
                ,   1, 
            LGGE,   1
        }

        OperationRegion (PEGR, PCI_Config, Zero, 0x0100)
        Field (PEGR, DWordAcc, Lock, Preserve)
        {
                    Offset (0x4C), 
            SSID,   32
        }

        Name (GSID, Zero)
        Name (HDID, Zero)
        Method (_ON, 0, Serialized)
        {
            \RGPU (One, \PGPU (One, Sleep (0x012C), \RGPU (Zero, Sleep (0x64), 
                Store (Zero, LLGE), Store (Zero, LGGE), Store (Zero, PEPO), Store (Zero, 
                ROE0)), Store (Zero, ROE1)), Store (Zero, ROE2), Store (Zero, ROE3), Store (
                Zero, ROE4), Store (Zero, ROE5))
            Store (Zero, ROE6)
            Store (Zero, ROE7)
            Store (Zero, ROE8)
            Store (Zero, ROE9)
            Store (Zero, ROEA)
            Store (Zero, ROEB)
            Store (Zero, ROEC)
            Store (Zero, ROED)
            Store (Zero, ROEE)
            Store (Zero, ROEF)
            Store (Zero, HCLQ)
            Store (Zero, RFC9)
            Store (Zero, PEDQ)
            Store (Zero, LNKD)
            Store (One, LLGE)
            Store (One, LGGE)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Store (GSID, SSID)
            Store (HDID, \_SB.PCI0.RP00.EHDA.SSID)
            Notify (\_SB.PCI0.RP00, Zero)
            Sleep (0x64)
            Notify (\_SB.PCI0.VGA, Zero)
        }

        Method (_OFF, 0, Serialized)
        {
            Store (SSID, GSID)
            Store (\_SB.PCI0.RP00.EHDA.SSID, HDID)
            Store (Zero, LLGE)
            Store (Zero, LGGE)
            Store (One, LNKD)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            Store (One, PEDQ)
            Store (Zero, LNKD)
            While (LNotEqual (PIDQ, One))
            {
                Sleep (One)
            }

            Store (One, HCLQ)
            Store (One, RFC9)
            Store (0x03, PEPO)
            Store (One, ROE0)
            Store (One, ROE1)
            Store (One, ROE2)
            Store (One, ROE3)
            Store (One, ROE4)
            Store (One, ROE5)
            Store (One, ROE6)
            Store (One, ROE7)
            Store (One, ROE8)
            Store (One, ROE9)
            Store (One, ROEA)
            Store (One, ROEB)
            Store (One, ROEC)
            Store (One, ROED)
            Store (One, ROEE)
            Store (One, ROEF)
            Store (One, LLGE)
            Store (One, LGGE)
            \RGPU (One, \PGPU (Zero, Notify (\_SB.PCI0.RP00, Zero), Sleep (0x64), Notify (
                \_SB.PCI0.VGA, Zero)))
        }

        Method (_STA, 0, Serialized)
        {
            Store (\GPOW, Local0)
            If (Local0)
            {
                Return (0x0F)
            }

            Return (Zero)
        }
    }

    Scope (\_SB.PCI0.VGA)
    {
        OperationRegion (APXM, SystemMemory, AMDA (0x00010400), Field (APXM, AnyAcc, NoLock, Preserve)
            {
                APSG,   128, 
                APSZ,   32, 
                APVR,   32, 
                        Offset (0x100), 
                APXA,   32, 
                RVBS,   32, 
                TVBO,   32, 
                PXEN,   8, 
                        Offset (0x180), 
                NTLE,   16, 
                TLE1,   16, 
                TLE2,   16, 
                TLE3,   16, 
                TLE4,   16, 
                TLE5,   16, 
                TLE6,   16, 
                TLE7,   16, 
                TLE8,   16, 
                TLE9,   16, 
                TL10,   16, 
                TL11,   16, 
                TL12,   16, 
                TL13,   16, 
                TL14,   16, 
                TL15,   16, 
                        Offset (0x200), 
                TGXA,   16, 
                AGXA,   16, 
                GSTP,   8, 
                        Offset (0x210), 
                DSWR,   8, 
                EMDR,   8, 
                TSTR,   8, 
                FPSR,   8, 
                SPSR,   8, 
                DCFR,   8, 
                PXGS,   8, 
                        Offset (0x230), 
                TSTG,   8, 
                TSSI,   8, 
                FPTG,   8, 
                FPSI,   8, 
                SPWS,   8, 
                        Offset (0x250), 
                        Offset (0x252), 
                CACD,   16, 
                CCND,   16, 
                NACD,   16, 
                TLST,   8, 
                LDST,   8, 
                        Offset (0x3C0), 
                        Offset (0x3C1), 
                EXPM,   8, 
                        Offset (0x3C4), 
                        Offset (0x3C6), 
                TLSN,   16, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
        Name (SGND, Zero)
        Name (SGUD, One)
        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                If (LEqual (Arg2, Zero))
                {
                    Return (Buffer (0x04)
                    {
                        0x03, 0x00, 0x00, 0x00
                    })
                }

                If (LEqual (Arg2, One))
                {
                    Name (MXIF, Package (0x06)
                    {
                        0x05, 
                        Package (0x02)
                        {
                            0x80010100, 
                            Buffer (0x04)
                            {
                                0x01, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010400, 
                            Buffer (0x04)
                            {
                                0x02, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010300, 
                            Buffer (0x04)
                            {
                                0x08, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010301, 
                            Buffer (0x04)
                            {
                                0x04, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010302, 
                            Buffer (0x04)
                            {
                                0x0E, 0x03, 0x03, 0x03
                            }
                        }
                    })
                    Return (MXIF)
                }

                Return (One)
            }

            Return (One)
        }

        Method (ATPX, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F0SS)
                CreateWordField (TMP1, 0x02, F0IV)
                CreateDWordField (TMP1, 0x04, F0SF)
                Store (0x08, F0SS)
                Store (One, F0IV)
                Store (0xBF, F0SF)
                Return (TMP1)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F1SS)
                CreateDWordField (TMP2, 0x02, F1VM)
                CreateDWordField (TMP2, 0x06, F1FG)
                Store (0x0A, F1SS)
                Store (0x7F, F1VM)
                Store (0x4B, F1FG)
                Return (TMP2)
            }

            If (LEqual (Arg0, 0x02))
            {
                CreateWordField (Arg1, Zero, FN2S)
                CreateByteField (Arg1, 0x02, DGPR)
                If (LEqual (DGPR, Zero))
                {
                    \_SB.PCI0.RP00.VGA._OFF ()
                    \VFAN (Zero)
                }

                If (LEqual (DGPR, One))
                {
                    \_SB.PCI0.RP00.VGA._ON ()
                    \VFAN (One)
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x03))
            {
                CreateWordField (Arg1, Zero, FN3S)
                CreateWordField (Arg1, 0x02, SDMG)
                If (LEqual (SDMG, Zero))
                {
                    \SGPU (Zero)
                }

                If (LEqual (SDMG, One))
                {
                    \SGPU (One)
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x04))
            {
                CreateWordField (Arg1, Zero, FN4S)
                CreateWordField (Arg1, 0x02, SIMG)
                If (LEqual (SIMG, Zero))
                {
                    \SGED (Zero)
                }

                If (LEqual (SIMG, One))
                {
                    \SGED (One)
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x05))
            {
                CreateWordField (Arg1, Zero, FN5S)
                CreateWordField (Arg1, 0x02, TGFX)
                Store (TGFX, TGXA)
                Store (One, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x06))
            {
                CreateWordField (Arg1, Zero, FN6S)
                CreateWordField (Arg1, 0x02, AGFX)
                Store (AGFX, AGXA)
                Store (Zero, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x08))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, NOCN)
                CreateWordField (TMP3, 0x02, CNSS)
                Store (0x0A, NOCN)
                Store (0x32, CNSS)
                CreateByteField (TMP3, 0x04, FLG1)
                CreateByteField (TMP3, 0x05, ATI1)
                CreateByteField (TMP3, 0x06, ADI1)
                CreateWordField (TMP3, 0x07, ACP1)
                Store (0x05, FLG1)
                Store (One, ATI1)
                Store (Zero, ADI1)
                Store (0x0100, ACP1)
                CreateByteField (TMP3, 0x09, FLG2)
                CreateByteField (TMP3, 0x0A, ATI2)
                CreateByteField (TMP3, 0x0B, ADI2)
                CreateWordField (TMP3, 0x0C, ACP2)
                Store (0x05, FLG2)
                Store (One, ATI2)
                Store (One, ADI2)
                Store (0x0100, ACP2)
                CreateByteField (TMP3, 0x0E, FLG3)
                CreateByteField (TMP3, 0x0F, ATI3)
                CreateByteField (TMP3, 0x10, ADI3)
                CreateWordField (TMP3, 0x11, ACP3)
                Store (0x05, FLG3)
                Store (Zero, ATI3)
                Store (Zero, ADI3)
                Store (0x0400, ACP3)
                CreateByteField (TMP3, 0x13, FLG4)
                CreateByteField (TMP3, 0x14, ATI4)
                CreateByteField (TMP3, 0x15, ADI4)
                CreateWordField (TMP3, 0x16, ACP4)
                Store (0x05, FLG4)
                Store (Zero, ATI4)
                Store (One, ADI4)
                Store (0x0110, ACP4)
                CreateByteField (TMP3, 0x18, FLG5)
                CreateByteField (TMP3, 0x19, ATI5)
                CreateByteField (TMP3, 0x1A, ADI5)
                CreateWordField (TMP3, 0x1B, ACP5)
                Store (0x07, FLG5)
                Store (0x03, ATI5)
                Store (Zero, ADI5)
                Store (0x0300, ACP5)
                CreateByteField (TMP3, 0x1D, FLG6)
                CreateByteField (TMP3, 0x1E, ATI6)
                CreateByteField (TMP3, 0x1F, ADI6)
                CreateWordField (TMP3, 0x20, ACP6)
                Store (0x07, FLG6)
                Store (0x03, ATI6)
                Store (One, ADI6)
                Store (0x0210, ACP6)
                CreateByteField (TMP3, 0x22, FLG7)
                CreateByteField (TMP3, 0x23, ATI7)
                CreateByteField (TMP3, 0x24, ADI7)
                CreateWordField (TMP3, 0x25, ACP7)
                Store (0x07, FLG7)
                Store (0x07, ATI7)
                Store (Zero, ADI7)
                Store (0x0301, ACP7)
                CreateByteField (TMP3, 0x27, FLG8)
                CreateByteField (TMP3, 0x28, ATI8)
                CreateByteField (TMP3, 0x29, ADI8)
                CreateWordField (TMP3, 0x2A, ACP8)
                Store (0x07, FLG8)
                Store (0x07, ATI8)
                Store (One, ADI8)
                Store (0x0220, ACP8)
                CreateByteField (TMP3, 0x2C, FLG9)
                CreateByteField (TMP3, 0x2D, ATI9)
                CreateByteField (TMP3, 0x2E, ADI9)
                CreateWordField (TMP3, 0x2F, ACP9)
                Store (0x07, FLG9)
                Store (0x09, ATI9)
                Store (Zero, ADI9)
                Store (0x0302, ACP9)
                CreateByteField (TMP3, 0x31, FLGA)
                CreateByteField (TMP3, 0x32, ATIA)
                CreateByteField (TMP3, 0x33, ADIA)
                CreateWordField (TMP3, 0x34, ACPA)
                Store (0x07, FLGA)
                Store (0x09, ATIA)
                Store (One, ADIA)
                Store (0x0230, ACPA)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (ATRM, 2, Serialized)
        {
            P8XH (One, 0xA0)
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }

        Method (ATIF, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP0, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP0, Zero, F0SS)
                CreateWordField (TMP0, 0x02, F0IV)
                CreateDWordField (TMP0, 0x04, F0SN)
                CreateDWordField (TMP0, 0x08, F0SF)
                Store (0x0C, F0SS)
                Store (One, F0IV)
                Store (0x41, F0SN)
                Store (0x07, F0SF)
                Return (TMP0)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F1SS)
                CreateDWordField (TMP1, 0x02, F1VF)
                CreateDWordField (TMP1, 0x06, F1FG)
                Store (0x0A, F1SS)
                Store (0x03, F1VF)
                Store (One, F1FG)
                Return (TMP1)
            }

            If (LEqual (Arg0, 0x02))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F2SS)
                CreateDWordField (TMP2, 0x02, F2PR)
                CreateByteField (TMP2, 0x06, F2EM)
                CreateByteField (TMP2, 0x07, F2TG)
                CreateByteField (TMP2, 0x08, F2SI)
                CreateByteField (TMP2, 0x09, F2FG)
                CreateByteField (TMP2, 0x0A, F2FI)
                CreateByteField (TMP2, 0x0B, F2SP)
                Store (0x0C, F2SS)
                Store (\_SB.SGRQ, F2PR)
                Store (Zero, \_SB.SGRQ)
                Return (TMP2)
            }

            If (LEqual (Arg0, 0x03))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, F3SS)
                CreateWordField (TMP3, 0x02, F3SD)
                CreateWordField (Arg1, Zero, AI3S)
                CreateWordField (Arg1, 0x02, SLDS)
                CreateWordField (Arg1, 0x04, CODS)
                Store (SLDS, Local0)
                Store (CODS, Local1)
                Store (0x04, F3SS)
                Or (Local1, One, Local1)
                \SVSA (Local0)
                If (LEqual (\_SB.SGFN, One))
                {
                    Store (Zero, \_SB.SGFN)
                    If (SGUD)
                    {
                        Store (Local0, SGND)
                        Store (Zero, SGUD)
                    }

                    Store (\SGNX (SGND, Local1, Local2, And (Local2, 0x0FFF, SGND), ShiftRight (
                        Local2, 0x10, Local2), And (Local2, 0xFF, Local2)), \SGAK)
                    Local2
                    Store (Zero, F3SD)
                    Return (TMP3)
                }

                If (LEqual (\_SB.SGFN, 0x02))
                {
                    Store (Zero, \_SB.SGFN)
                    Store (One, SGUD)
                    Store (SGND, F3SD)
                    Return (TMP3)
                }

                Store (Zero, \_SB.SGFN)
                Store (Zero, F3SD)
                Return (TMP3)
            }

            Return (Zero)
        }
    }

    Method (IDAB, 0, Serialized)
    {
    }
}

